CodeForces 722C Destroying Array (并查集)

题意:给定 n 个数,然后每次破坏一个位置的数,那么剩下的连通块的和最大是多少。

析:用并查集来做,从后往前推,一开始什么也没有,如果破坏一个,那么我们就加上一个,然后判断它左右两侧是不是存在,如果存在,那么就合并起来,

然后不断最大值,因为这个最大值肯定是不递减,所以我们一直更新就好。

代码如下:

#pragma comment(linker, "/STACK:1024000000,1024000000")
#include <cstdio>
#include <string>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <cstring>
#include <set>
#include <queue>
#include <algorithm>
#include <vector>
#include <map>
#include <cctype>
#include <cmath>
#include <stack>
//#include <tr1/unordered_map>
#define freopenr freopen("in.txt", "r", stdin)
#define freopenw freopen("out.txt", "w", stdout)
using namespace std;
//using namespace std :: tr1;

typedef long long LL;
typedef pair<int, int> P;
const int INF = 0x3f3f3f3f;
const double inf = 0x3f3f3f3f3f3f;
const LL LNF = 0x3f3f3f3f3f3f;
const double PI = acos(-1.0);
const double eps = 1e-8;
const int maxn = 1e5 + 5;
const LL mod = 10000000000007;
const int N = 1e6 + 5;
const int dr[] = {-1, 0, 1, 0, 1, 1, -1, -1};
const int dc[] = {0, 1, 0, -1, 1, -1, 1, -1};
const char *Hex[] = {"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111", "1000", "1001", "1010", "1011", "1100", "1101", "1110", "1111"};
inline LL gcd(LL a, LL b){  return b == 0 ? a : gcd(b, a%b); }
int n, m;
const int mon[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
const int monn[] = {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
inline int Min(int a, int b){ return a < b ? a : b; }
inline int Max(int a, int b){ return a > b ? a : b; }
inline LL Min(LL a, LL b){ return a < b ? a : b; }
inline LL Max(LL a, LL b){ return a > b ? a : b; }
inline bool is_in(int r, int c){
    return r >= 0 && r < n && c >= 0 && c < m;
}
int a[maxn], b[maxn], p[maxn];
bool num[maxn];
vector<LL> ans;
LL ran[maxn];

int Find(int x) {  return x == p[x] ? x : p[x] = Find(p[x]); }

int main(){
    while(scanf("%d", &n) == 1){
        for(int i = 1; i <= n; ++i){  scanf("%d", a+i); p[i] = i; }
        for(int i = 1; i <= n; ++i)  scanf("%d", b+i);

        ans.clear();
        memset(num, false, sizeof num);
        LL cnt = 0;
        for(int i = n; i > 0; --i){
            ans.push_back(cnt);
            int x = b[i];
            num[x] = true;
            ran[x] = a[x];
            if(num[x+1]){
                int y = Find(x+1);
                p[y] = x;
                ran[x] += ran[y];
            }
            if(num[x-1]){
                int y = Find(x-1);
                p[y] = x;
                ran[x] += ran[y];
            }
            cnt = Max(cnt, ran[x]);
        }

        for(int i = ans.size()-1; i >= 0; --i)
            printf("%I64d
", ans[i]);
    }
    return 0;
}
原文地址:https://www.cnblogs.com/dwtfukgv/p/5930141.html